VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "LinkMappingUnit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'      
Option Explicit

Private m_ReplaceMap As Collection

'---------- Public Interface ----------
Public Function FixLink(ByRef adr$) As LMU_Return
'  
  Dim testAdr$
  If Not IsFSO(adr, "") Then
    FixLink = RV_NOTAFSO
    Exit Function
  End If
  
  If IsValidAddress(adr) Then
    testAdr = ConvertLinkToURL(adr)
    If CheckFile(testAdr, testAdr) Then
      FixLink = RV_LINK_OK
      Exit Function
    End If
  End If
  
  testAdr = SwapStrgServer(adr)
  If CheckFile(testAdr, testAdr) Then
    FixLink = RV_LINK_FIXED
    adr = ConvertLinkToLocal(testAdr)
    Exit Function
  End If
  
  Dim j&, k&
  Dim rule As LMUItem
  Dim result$
  For j = 1 To m_ReplaceMap.Count
    Set rule = m_ReplaceMap.Item(j)
    If InStr(adr, rule.repWhat) = 0 Then _
      GoTo NEXT_RULE
    
    For k = 1 To rule.repList.Count
      result = Replace(testAdr, rule.repWhat, rule.repList(k))
      If CheckFile(result, "") Then
        adr = ConvertLinkToLocal(result)
        FixLink = RV_LINK_FIXED
        Exit Function
      End If
    Next k
NEXT_RULE:
  Next j
  
  FixLink = RV_LINK_NOFIX
End Function

'---------- Event handlers and misc code ----------
Private Sub Class_Initialize()
  Set m_ReplaceMap = New Collection
  Dim rule As LMUItem
  Set rule = New LMUItem
  rule.repWhat = "01 Income-"
  rule.repList.Add ("00 \01 ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "02 Outcome-"
  rule.repList.Add ("00 \02 ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "03  "
  rule.repList.Add ("00 \03 ")
  rule.repList.Add ("01 Income-")
  rule.repList.Add ("02 Outcome-")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "031  "
  rule.repList.Add ("00 \03 ")
  rule.repList.Add ("03  ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "05  \"
  rule.repList.Add ("05  \04 ")
  Call m_ReplaceMap.Add(rule)
End Sub

Private Function IsValidAddress(ByVal addr$) As Boolean
  IsValidAddress = True
  If Left(addr, Len("\\server\Projects")) Like "\\[Ss][Ee][Rr][Vv][Ee][Rr]\[Pp]rojects" Then IsValidAddress = False
  If Left(addr, Len("\\strg1\Exchange")) Like "\\[Ss][Tt][Rr][Gg]1\[Ee]xchange" Then IsValidAddress = False
End Function

Private Function IsFSO(addr$, docpath$) As Boolean
'  
  addr = GetFullPath(addr, docpath)
  If Left(addr, 3) Like "[PpXx]:\" Then IsFSO = True: Exit Function
  If Left(addr, 16) Like "\\[Ss][Tt][Rr][Gg]1\[Pp]rojects" Then IsFSO = True: Exit Function
  If Left(addr, 16) Like "\\[Ss][Tt][Rr][Gg]1\[Ee]xchange" Then IsFSO = True: Exit Function
  If Left(addr, 17) Like "\\[Ss][Ee][Rr][Vv][Ee][Rr]\[Ee]xchange" Then IsFSO = True: Exit Function
  If Left(addr, 17) Like "\\[Ss][Ee][Rr][Vv][Ee][Rr]\[Pp]rojects" Then IsFSO = True: Exit Function
  
  IsFSO = False
End Function

Private Function CheckFile(ByVal addr$, currentPath$) As Boolean
'   
  If Left(addr, 1) = "." Or InStr(addr, "\") + InStr(addr, "/") = 0 Then _
    addr = currentPath & "\" & addr
  
  On Error Resume Next
  CheckFile = Len(Dir(addr)) <> 0 Or Len(Dir(addr, vbDirectory)) <> 0
End Function

Private Function SwapStrgServer(ByVal addr$)
  SwapStrgServer = addr
  If Left(addr, Len("\\server\Projects")) Like "\\[Ss][Ee][Rr][Vv][Ee][Rr]\[Pp]rojects" Then _
    SwapStrgServer = "P:\" + Right(addr, Len(addr) - Len("\\server\Projects\"))
  If Left(addr, Len("\\strg1\Exchange")) Like "\\[Ss][Tt][Rr][Gg]1\[Ee]xchange" Then _
    SwapStrgServer = "X:\" + Right(addr, Len(addr) - Len("\\strg1\Exchange\"))
End Function

